FIND_PACKAGE(LAPACK)

FILE(GLOB
  INC
  includes/*.h
)

DEFINE_INCLUDES(${INC})

FILE(GLOB
  ELEMENTARIES_FUNCTIONS_C_SOURCES
  src/c/sci_tools.c  
  src/c/finite.c  
  src/c/vfinite.c  
  src/c/cmp.c  
  src/c/vceil.c  
  src/c/xerhlt.c  
  src/c/vfloor.c  
  src/c/vfrexp.c  
  src/c/scidcopy.c  
  src/c/int2db.c  
  src/c/rea2db.c  
  src/c/idmax.c  
  src/c/idmin.c  
  src/c/gsort.c  
  src/c/qsort.c  
  src/c/qsort-char.c  
  src/c/qsort-double.c  
  src/c/qsort-int.c  
  src/c/qsort-short.c  
  src/c/qsort-string.c  
  src/c/IsEqualVar.c
)

FILE(GLOB
  SLATEC_SOURCES
  src/fortran/slatec/zwrsk.f  
  src/fortran/slatec/d9b0mp.f  
  src/fortran/slatec/d9b1mp.f  
  src/fortran/slatec/d9knus.f  
  src/fortran/slatec/d9lgmc.f  
  src/fortran/slatec/dasyik.f  
  src/fortran/slatec/dasyjy.f  
  src/fortran/slatec/dbdiff.f  
  src/fortran/slatec/dbesi0.f  
  src/fortran/slatec/dbesi1.f  
  src/fortran/slatec/dbesi.f  
  src/fortran/slatec/dbesj0.f  
  src/fortran/slatec/dbesj1.f  
  src/fortran/slatec/dbesj.f  
  src/fortran/slatec/dbesk0.f  
  src/fortran/slatec/dbesk1.f  
  src/fortran/slatec/dbesk.f  
  src/fortran/slatec/dbesks.f  
  src/fortran/slatec/dbesy0.f  
  src/fortran/slatec/dbesy1.f  
  src/fortran/slatec/dbesy.f  
  src/fortran/slatec/dbkias.f  
  src/fortran/slatec/dbkisr.f  
  src/fortran/slatec/dbsi0e.f  
  src/fortran/slatec/dbsi1e.f  
  src/fortran/slatec/dbsk0e.f  
  src/fortran/slatec/dbsk1e.f  
  src/fortran/slatec/dbskes.f  
  src/fortran/slatec/dbskin.f  
  src/fortran/slatec/dbsknu.f  
  src/fortran/slatec/dbsynu.f  
  src/fortran/slatec/dcsevl.f  
  src/fortran/slatec/dexint.f  
  src/fortran/slatec/dgamlm.f  
  src/fortran/slatec/dgamln.f  
  src/fortran/slatec/dgamma.f  
  src/fortran/slatec/dgamrn.f  
  src/fortran/slatec/dhkseq.f  
  src/fortran/slatec/djairy.f  
  src/fortran/slatec/dpsixn.f  
  src/fortran/slatec/dxlegf.f  
  src/fortran/slatec/dyairy.f  
  src/fortran/slatec/fdump.f  
  src/fortran/slatec/gamma.f  
  src/fortran/slatec/initds.f  
  src/fortran/slatec/j4save.f  
  src/fortran/slatec/xercnt.f  
  src/fortran/slatec/xermsg.f  
  src/fortran/slatec/xerprn.f  
  src/fortran/slatec/xersve.f  
  src/fortran/slatec/xgetua.f  
  src/fortran/slatec/zabs.f  
  src/fortran/slatec/zacai.f  
  src/fortran/slatec/zacon.f  
  src/fortran/slatec/zairy.f  
  src/fortran/slatec/zasyi.f  
  src/fortran/slatec/zbesh.f  
  src/fortran/slatec/zbesi.f  
  src/fortran/slatec/zbesj.f  
  src/fortran/slatec/zbesk.f  
  src/fortran/slatec/zbesy.f  
  src/fortran/slatec/zbinu.f  
  src/fortran/slatec/zbknu.f  
  src/fortran/slatec/zbuni.f  
  src/fortran/slatec/zbunk.f  
  src/fortran/slatec/zdiv.f  
  src/fortran/slatec/zexp.f  
  src/fortran/slatec/zkscl.f  
  src/fortran/slatec/zlog.f  
  src/fortran/slatec/zmlri.f  
  src/fortran/slatec/zmlt.f  
  src/fortran/slatec/zrati.f  
  src/fortran/slatec/zs1s2.f  
  src/fortran/slatec/zseri.f  
  src/fortran/slatec/zshch.f  
  src/fortran/slatec/zsqrt.f  
  src/fortran/slatec/zuchk.f  
  src/fortran/slatec/zunhj.f  
  src/fortran/slatec/zuni1.f  
  src/fortran/slatec/zuni2.f  
  src/fortran/slatec/zunik.f  
  src/fortran/slatec/zunk1.f  
  src/fortran/slatec/zunk2.f  
  src/fortran/slatec/zuoik.f  
  src/fortran/slatec/dlngam.f  
  src/fortran/slatec/balanc.f  
  src/fortran/slatec/dtensbs.f  
  src/fortran/slatec/pchim.f
)

FILE(GLOB
LINPACK_SOURCES
  src/fortran/linpack/dgesl.f  
  src/fortran/linpack/wpade.f  
  src/fortran/linpack/util.f  
  src/fortran/linpack/wcopy.f  
  src/fortran/linpack/dgefa.f  
  src/fortran/linpack/dgbfa.f  
  src/fortran/linpack/dgeco.f  
  src/fortran/linpack/dgedi.f  
  src/fortran/linpack/dqrdc.f  
  src/fortran/linpack/dqrsl.f  
  src/fortran/linpack/dqrsm.f  
  src/fortran/linpack/hhdml.f  
  src/fortran/linpack/spofa.f  
  src/fortran/linpack/wgeco.f  
  src/fortran/linpack/wgefa.f  
  src/fortran/linpack/wgesl.f  
  src/fortran/linpack/dpofa.f  
  src/fortran/linpack/util.f
)


FILE(GLOB
  ELEMENTARIES_FUNCTIONS_FORTRAN_SOURCES   
  src/fortran/psi.f  
  src/fortran/wasum.f  
  src/fortran/dexpm1.f  
  src/fortran/wwdiv.f  
  src/fortran/wdotcr.f  
  src/fortran/iset.f  
  src/fortran/franck.f  
  src/fortran/dwpowe.f  
  src/fortran/rcsort.f  
  src/fortran/wddiv.f  
  src/fortran/lnblnk.f  
  src/fortran/entier.f  
  src/fortran/round.f  
  src/fortran/cortr.f  
  src/fortran/simple.f  
  src/fortran/split.f  
  src/fortran/wdrdiv.f  
  src/fortran/imcopy.f  
  src/fortran/cbal.f  
  src/fortran/cuproi.f  
  src/fortran/dsum.f  
  src/fortran/urand.f  
  src/fortran/intp.f  
  src/fortran/watan.f  
  src/fortran/wipowe.f  
  src/fortran/wacos.f  
  src/fortran/wdpow1.f  
  src/fortran/zbesjg.f  
  src/fortran/dmsum.f  
  src/fortran/dlgama.f  
  src/fortran/exch.f  
  src/fortran/wsign.f  
  src/fortran/kronr.f  
  src/fortran/wrscal.f  
  src/fortran/pythag.f  
  src/fortran/dbeskg.f  
  src/fortran/dmmul1.f  
  src/fortran/dwpow.f  
  src/fortran/wmmul.f  
  src/fortran/dsearch.f  
  src/fortran/ddif.f  
  src/fortran/wdiv.f  
  src/fortran/wtan.f  
  src/fortran/ccopy.f  
  src/fortran/ddpow.f  
  src/fortran/magic.f  
  src/fortran/wcerr.f  
  src/fortran/ivimp.f  
  src/fortran/cupro.f  
  src/fortran/dadd.f  
  src/fortran/calerf.f  
  src/fortran/isort.f  
  src/fortran/hilber.f  
  src/fortran/wdpowe.f  
  src/fortran/wmprod.f  
  src/fortran/wscal.f  
  src/fortran/dlblks.f  
  src/fortran/kronc.f  
  src/fortran/ddrdiv.f  
  src/fortran/dipow.f  
  src/fortran/wshrsl.f  
  src/fortran/wwrdiv.f  
  src/fortran/zbeshg.f  
  src/fortran/coshin.f  
  src/fortran/iwamax.f  
  src/fortran/dipowe.f  
  src/fortran/getorient.f  
  src/fortran/cusum.f  
  src/fortran/dbesig.f  
  src/fortran/d1mach.f  
  src/fortran/wbdiag.f  
  src/fortran/ddpow1.f  
  src/fortran/vpythag.f  
  src/fortran/isova0.f  
  src/fortran/wswap.f  
  src/fortran/wwpow1.f  
  src/fortran/getdimfromvar.f  
  src/fortran/gdcp2i.f  
  src/fortran/drdiv.f  
  src/fortran/wmsum.f  
  src/fortran/dbesyg.f  
  src/fortran/corth.f  
  src/fortran/mtran.f  
  src/fortran/wwpow.f  
  src/fortran/zbeskg.f  
  src/fortran/dvmul.f  
  src/fortran/wclmat.f  
  src/fortran/dsort.f  
  src/fortran/cerr.f  
  src/fortran/rcopy.f  
  src/fortran/wdpow.f  
  src/fortran/orthes.f  
  src/fortran/waxpy.f  
  src/fortran/coef.f  
  src/fortran/dwdiv.f  
  src/fortran/arcosh.f  
  src/fortran/wasin.f  
  src/fortran/wexpm1.f  
  src/fortran/ddpowe.f  
  src/fortran/nearfloat.f  
  src/fortran/dmprod.f  
  src/fortran/wwpowe.f  
  src/fortran/wdotci.f  
  src/fortran/dmcopy.f  
  src/fortran/wexchn.f  
  src/fortran/isoval.f  
  src/fortran/dwrdiv.f  
  src/fortran/wipow.f  
  src/fortran/wlog.f  
  src/fortran/infinity.f  
  src/fortran/dwpow1.f  
  src/fortran/zbesig.f  
  src/fortran/wmul.f  
  src/fortran/dad.f  
  src/fortran/dbesjg.f  
  src/fortran/dset.f  
  src/fortran/dtild.f  
  src/fortran/i1mach.f  
  src/fortran/zbesyg.f  
  src/fortran/dclmat.f  
  src/fortran/ortran.f  
  src/fortran/bdiag.f  
  src/fortran/wvmul.f  
  src/fortran/dmmul.f  
  src/fortran/wsort.f  
  src/fortran/wsqrt.f  
  src/fortran/rat.f  
  src/fortran/ribesl.f  
  src/fortran/rjbesl.f  
  src/fortran/rkbesl.f  
  src/fortran/rybesl.f  
  src/fortran/sdot.f
)

FILE(GLOB
  GATEWAY_C_SOURCES
  sci_gateway/c/sci_isequal.c  
  sci_gateway/c/sci_matrix.c  
  sci_gateway/c/sci_prod.c  
  sci_gateway/c/sci_expm.c  
  sci_gateway/c/sci_size.c  
  sci_gateway/c/sci_tril.c  
  sci_gateway/c/sci_ceil.c  
  sci_gateway/c/sci_imag.c  
  sci_gateway/c/sci_log.c  
  sci_gateway/c/sci_log1p.c  
  sci_gateway/c/sci_eye.c  
  sci_gateway/c/sci_clean.c  
  sci_gateway/c/sci_tan.c  
  sci_gateway/c/sci_atan.c  
  sci_gateway/c/sci_triu.c  
  sci_gateway/c/sci_frexp.c  
  sci_gateway/c/sci_cos.c  
  sci_gateway/c/sci_rand.c  
  sci_gateway/c/sci_acos.c  
  sci_gateway/c/sci_sin.c  
  sci_gateway/c/sci_sqrt.c  
  sci_gateway/c/sci_asin.c  
  sci_gateway/c/sci_sign.c  
  sci_gateway/c/sci_zeros.c  
  sci_gateway/c/sci_ones.c  
  sci_gateway/c/gw_elementary_functions.c  
  sci_gateway/c/sci_number_properties.c  
  sci_gateway/c/sci_diag.c  
  sci_gateway/c/sci_sum.c  
  sci_gateway/c/sci_testmatrix.c  
  sci_gateway/c/sci_abs.c  
  sci_gateway/c/sci_spones.c  
  sci_gateway/c/sci_kron.c  
  sci_gateway/c/sci_cumprod.c  
  sci_gateway/c/sci_cumsum.c  
  sci_gateway/c/sci_dsearch.c  
  sci_gateway/c/sci_nearfloat.c  
  sci_gateway/c/sci_chinesehat.c  
  sci_gateway/c/sci_isreal.c  
  sci_gateway/c/sci_floor.c  
  sci_gateway/c/sci_real.c  
  sci_gateway/c/sci_round.c  
  sci_gateway/c/sci_conj.c  
  sci_gateway/c/sci_int.c  
  sci_gateway/c/sci_imult.c  
  sci_gateway/c/sci_exp.c  
  sci_gateway/c/sci_maxi.c  
  sci_gateway/c/sci_gsort.c  
  sci_gateway/c/sci_sort.c  
  sci_gateway/c/sci_isequalbitwise.c
)

FILE(GLOB
  GATEWAY_FORTRAN_SOURCES
  sci_gateway/fortran/sci_f_isequal.f  
  sci_gateway/fortran/sci_f_maxi.f  
  sci_gateway/fortran/sci_f_testmatrix.f  
  sci_gateway/fortran/sci_f_prod.f  
  sci_gateway/fortran/sci_f_matrix.f  
  sci_gateway/fortran/sci_f_expm.f  
  sci_gateway/fortran/sci_f_size.f  
  sci_gateway/fortran/sci_f_tril.f  
  sci_gateway/fortran/sci_f_ceil.f  
  sci_gateway/fortran/sci_f_imag.f  
  sci_gateway/fortran/sci_f_log.f  
  sci_gateway/fortran/sci_f_log1p.f  
  sci_gateway/fortran/sci_f_clean.f  
  sci_gateway/fortran/sci_f_eye.f  
  sci_gateway/fortran/sci_f_tan.f  
  sci_gateway/fortran/sci_f_atan.f  
  sci_gateway/fortran/sci_f_triu.f  
  sci_gateway/fortran/sci_f_frexp.f  
  sci_gateway/fortran/sci_f_cos.f  
  sci_gateway/fortran/sci_f_rand.f  
  sci_gateway/fortran/sci_f_acos.f  
  sci_gateway/fortran/sci_f_sin.f  
  sci_gateway/fortran/sci_f_sqrt.f  
  sci_gateway/fortran/sci_f_asin.f  
  sci_gateway/fortran/sci_f_sign.f  
  sci_gateway/fortran/sci_f_zeros.f  
  sci_gateway/fortran/sci_f_ones.f  
  sci_gateway/fortran/sci_f_diag.f  
  sci_gateway/fortran/sci_f_number_properties.f  
  sci_gateway/fortran/sci_f_sum.f  
  sci_gateway/fortran/sci_f_cumprod.f  
  sci_gateway/fortran/sci_f_abs.f  
  sci_gateway/fortran/sci_f_spones.f  
  sci_gateway/fortran/sci_f_kron.f  
  sci_gateway/fortran/sci_f_dsearch.f  
  sci_gateway/fortran/sci_f_cumsum.f  
  sci_gateway/fortran/sci_f_nearfloat.f  
  sci_gateway/fortran/sci_f_chinesehat.f  
  sci_gateway/fortran/sci_f_isreal.f  
  sci_gateway/fortran/sci_f_floor.f  
  sci_gateway/fortran/sci_f_real.f  
  sci_gateway/fortran/sci_f_round.f  
  sci_gateway/fortran/sci_f_conj.f  
  sci_gateway/fortran/sci_f_int.f  
  sci_gateway/fortran/sci_f_imult.f  
  sci_gateway/fortran/sci_f_exp.f  
  sci_gateway/fortran/sci_f_sort.f 
)

FILE(GLOB
  EISPACK_SOURCES
  src/fortran/eispack/balbak.f
)

ADD_LIBRARY(dummy-elementary_functions
  src/fortran/eispack/hqror2.f
  src/fortran/comqr3.f
  src/fortran/linpack/pade.f
  src/c/unsfdcopy.c
  src/fortran/linpack/icopy.f
)

ADD_LIBRARY(elementary_functions 
  ${SLATEC_SOURCES}
  ${LINPACK_SOURCES}  
  ${EISPACK_SOURCES}
  ${ELEMENTARIES_FUNCTIONS_C_SOURCES}
  ${ELEMENTARIES_FUNCTIONS_FORTRAN_SOURCES} 
  ${GATEWAY_C_SOURCES}
  ${GATEWAY_FORTRAN_SOURCES}
  ${ELEMENTARIES_FUNCTIONS_CPP_SOURCES}
)

TARGET_LINK_LIBRARIES(elementary_functions
  dummy-elementary_functions
  ${LAPACK_LIBRARIES}
)